#ifndef __NLL_CONST_H_INCLUDED__
#define __NLL_CONST_H_INCLUDED__

#define NLL_D_VARIABLE (1 <<  0)
#define NLL_D_STRING   (1 <<  1)
#define NLL_D_LABEL    (1 <<  2)
#define NLL_D_LINE     (1 <<  3)
#define NLL_D_STACK    (1 <<  4)
#define NLL_D_ALL      (NLL_D_VARIABLE|NLL_D_STRING|NLL_D_LABEL|NLL_D_LINE|NLL_D_STACK)
#define NLL_L_COMMAND  (1 << 16)
#define NLL_L_FUNCTION (1 << 17)
#define NLL_L_CONST    (1 << 18)

#define NLL_F_DISABLE  0
#define NLL_F_ENABLE   NLL_F_BUFFER
#define NLL_F_BUFFER   (1 <<  0)
#define NLL_F_FLUSH    (1 <<  1)
#define NLL_F_CURSOR   (1 <<  2)
#define NLL_F_CURSES   (1 <<  3)

#define NLL_F_FILL     (1 <<  0)

#define NLL_C_RESET      9
#define NLL_C_BLACK      0
#define NLL_C_RED        1
#define NLL_C_GREEN      2
#define NLL_C_YELLOW     3
#define NLL_C_BLUE       4
#define NLL_C_MAGENTA    5
#define NLL_C_CYAN       6
#define NLL_C_WHITE      7

#define NLL_A_RESET      0
#define NLL_A_BOLD       1
#define NLL_A_FAINT      2
#define NLL_A_ITALIC     3
#define NLL_A_UNDERLINE  4
#define NLL_A_BLINK      5
#define NLL_A_RAPIDBLINK 6
#define NLL_A_INVERSE    7
#define NLL_A_INVISIBLE  8
#define NLL_A_CROSSOUT   9

#ifdef USE_GRAPHIC
#define NLL_G_DISABLE   0
#define NLL_G_ENABLE    NLL_G_DIRECT
#define NLL_G_DIRECT    (1 <<  0)
#define NLL_G_BUFFER    (1 <<  1)
#define NLL_G_FLUSH     (1 <<  2)
#define NLL_G_RENDERER  (1 <<  3)
#define NLL_G_FORCE     (1 <<  4)
#define NLL_G_SYNC      (1 <<  5)
#define NLL_G_ROUGH     (1 <<  6)
#define NLL_G_HROUGH    (1 <<  7)
#define NLL_G_MAINIMG   -1

#define NLL_G_SET       (0x0 <<  0)
#define NLL_G_AND       (0x1 <<  0)
#define NLL_G_OR        (0x2 <<  0)
#define NLL_G_XOR       (0x3 <<  0)
#define NLL_G_MODE_MASK (0x3 <<  0)
#define NLL_G_FILL        (1 <<  2)

#define NLL_G_BLACK     0x000000
#define NLL_G_BLUE      0x0000FF
#define NLL_G_GREEN     0x00FF00
#define NLL_G_CYAN      0x00FFFF
#define NLL_G_RED       0xFF0000
#define NLL_G_MAGENTA   0xFF00FF
#define NLL_G_YELLOW    0xFFFF00
#define NLL_G_WHITE     0xFFFFFF
#endif

#ifdef USE_AUDIO
#define NLL_A_OUTPUT    0

#define NLL_A_SIN       0
#define NLL_A_TRIANGLE  1
#define NLL_A_RECTANGLE 2
#define NLL_A_SAWUP     3
#define NLL_A_SAWDOWN   4
#define NLL_A_RANDOM    5
#define NLL_A_NOISE     6
#define NLL_A_LEVEL     7

#define NLL_A_DEFENV    0
#define NLL_A_FLUSH     0
#define NLL_A_CLEARENV  (1 <<  0)
#define NLL_A_SAVE      (1 <<  1)
#define NLL_A_NEW       (1 <<  2)

#define NLL_A_PHASE     (0x0 <<  8)
#define NLL_A_FREQ      (0x1 <<  8)
#define NLL_A_VALUE     (0x2 <<  8)
#define NLL_A_NULL      (0x3 <<  8)
#define NLL_A_REV       (0x4 <<  8)
#define NLL_A_SIGN      (0x5 <<  8)
#define NLL_A_ADD       (0x6 <<  8)
#define NLL_A_SUB       (0x7 <<  8)
#define NLL_A_MUL       (0x8 <<  8)
#define NLL_A_AND       (0x9 <<  8)
#define NLL_A_OR        (0xA <<  8)
#define NLL_A_XOR       (0xB <<  8)
#define NLL_A_AVE       (0xC <<  8)
#define NLL_A_PER       (0xD <<  8)
#define NLL_A_MIN       (0xE <<  8)
#define NLL_A_MAX       (0xF <<  8)
#define NLL_A_LT       (0x10 <<  8)
#define NLL_A_GT       (0x11 <<  8)
#define NLL_A_MOD_MASK (0x1F <<  8)

#define NLL_A_DEFOSCSET 0
#endif

#endif
